﻿package {
	import flash.events.Event;
	import flash.filters.BlurFilter;
	import flash.text.TextField;
	import flash.utils.getTimer;
	import org.papervision3d.materials.BitmapMaterial;
	import org.papervision3d.objects.primitives.Sphere;
	import org.papervision3d.core.effects.view.ReflectionView;
	import org.papervision3d.materials.ColorMaterial;
	import org.papervision3d.materials.utils.MaterialsList;

	public class World extends ReflectionView{
		private var sphere1:Sphere;
		//球体の半径
		private var radius:Number = 100;
		
		public function World(){
			super(600, 600, false);
			//鏡面のＹ座標を設定
			surfaceHeight = -100;
			//鏡面の色を調整
			setReflectionColor(0.7, 0.7, 0.7);
			//鏡面をぼかしたい場合は下記フィルターを使う
			viewportReflection.filters = [new BlurFilter(10,10,2)]; 
			//球体を生成
			init(); 
			//カメラ位置調整
			camera.fov = 40;
			camera.y = 200;
			camera.z = -800;
			//毎フレーム更新
			addEventListener(Event.ENTER_FRAME, onEnterFrame); 
		}
 
		public function init() : void {
			//ライブラリにリンケージしてあるビットマップデータ
			var bmd = new TextureBitmapData(256,256);
			//球体のマテリアル
			var material1:BitmapMaterial = new BitmapMaterial(bmd);
			material1.smooth = true;
			//球体
			sphere1 = new Sphere(material1, radius);
			scene.addChild(sphere1);
		}
 
		public function onEnterFrame(e:Event) : void{
			//球体を回転、マウスに追随
			sphere1.rotationY += 1;
			sphere1.x=sphere1.z=mouseX-300;
			sphere1.y=300-mouseY; 
			//鏡面より下に行かないように
			if (sphere1.y < surfaceHeight / 2 + radius) {
				sphere1.y = surfaceHeight / 2 + radius; 
			}
			singleRender(); 
		}

	}
}